/* Generated from Extensions from the future */


#include <QtGlobal>

#include <QByteArray>
#include <QString>
#include <QStringList>
#include <QVariantList>
#include <QVariantMap>

#include <QDBusArgument>
#include <QDBusMetaType>
#include <QDBusObjectPath>
#include <QDBusSignature>
#include <QDBusVariant>

#include <TelepathyQt/Global>

/**
 * \addtogroup typesconstants Types and constants
 *
 * Enumerated, flag, structure, list and mapping types and utility constants.
 */

/**
 * \defgroup struct Structure types
 * \ingroup typesconstants
 *
 * Structure types generated from the specification.
 */

/**
 * \defgroup list List types
 * \ingroup typesconstants
 *
 * List types generated from the specification.
 */

/**
 * \defgroup mapping Mapping types
 * \ingroup typesconstants
 *
 * Mapping types generated from the specification.
 */


namespace TpFuture
{
/**
 * \struct ObjectImmutablePropertiesMap
 * \ingroup mapping
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Mapping type generated from the specification. Convertible with
 * QMap<QDBusObjectPath, QVariantMap>, but needed to have a discrete type in the Qt type system.
 * 
 * A mapping from object path to the immutable properties of the object.
 */
struct  ObjectImmutablePropertiesMap : public QMap<QDBusObjectPath, QVariantMap>
{
    ObjectImmutablePropertiesMap() : QMap<QDBusObjectPath, QVariantMap>() {}
    ObjectImmutablePropertiesMap(const QMap<QDBusObjectPath, QVariantMap>& a) : QMap<QDBusObjectPath, QVariantMap>(a) {}
    ObjectImmutablePropertiesMap(std::initializer_list<std::pair<QDBusObjectPath, QVariantMap> > a) : QMap<QDBusObjectPath, QVariantMap>(a) {}

    ObjectImmutablePropertiesMap& operator=(const QMap<QDBusObjectPath, QVariantMap>& a)
    {
        *(static_cast<QMap<QDBusObjectPath, QVariantMap>*>(this)) = a;
        return *this;
    }
};

/**
 * \ingroup list
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Array of ObjectImmutablePropertiesMap values.
 */
typedef QList<ObjectImmutablePropertiesMap> ObjectImmutablePropertiesMapList;

/**
 * \struct QualifiedPropertyValueMap
 * \ingroup mapping
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Mapping type generated from the specification. Convertible with
 * QMap<QString, QDBusVariant>, but needed to have a discrete type in the Qt type system.
 * 
 * A mapping from strings representing D-Bus properties (by their namespaced 
 * names) to their values.
 */
struct  QualifiedPropertyValueMap : public QMap<QString, QDBusVariant>
{
    QualifiedPropertyValueMap() : QMap<QString, QDBusVariant>() {}
    QualifiedPropertyValueMap(const QMap<QString, QDBusVariant>& a) : QMap<QString, QDBusVariant>(a) {}
    QualifiedPropertyValueMap(std::initializer_list<std::pair<QString, QDBusVariant> > a) : QMap<QString, QDBusVariant>(a) {}

    QualifiedPropertyValueMap& operator=(const QMap<QString, QDBusVariant>& a)
    {
        *(static_cast<QMap<QString, QDBusVariant>*>(this)) = a;
        return *this;
    }
};

/**
 * \ingroup list
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Array of QualifiedPropertyValueMap values.
 */
typedef QList<QualifiedPropertyValueMap> QualifiedPropertyValueMapList;

/**
 * \struct SocketAddressIP
 * \ingroup struct
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Structure type generated from the specification.
 * 
 * An IP address and port.
 */
struct  SocketAddressIP
{
    /**
     * Either a dotted-quad IPv4 address literal as for Socket_Address_IPv4, 
     * or an RFC2373 IPv6 address as for Socket_Address_IPv6.
     */
    QString address;
    /**
     * The TCP or UDP port number.
     */
    ushort port;
};

 bool operator==(const SocketAddressIP& v1, const SocketAddressIP& v2);
inline bool operator!=(const SocketAddressIP& v1, const SocketAddressIP& v2)
{
    return !operator==(v1, v2);
}
 QDBusArgument& operator<<(QDBusArgument& arg, const SocketAddressIP& val);
 const QDBusArgument& operator>>(const QDBusArgument& arg, SocketAddressIP& val);

/**
 * \ingroup list
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Array of SocketAddressIP values.
 */
typedef QList<SocketAddressIP> SocketAddressIPList;

/**
 * \struct SocketAddressIPv4
 * \ingroup struct
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Structure type generated from the specification.
 * 
 * An IPv4 address and port.
 */
struct  SocketAddressIPv4
{
    /**
     * A dotted-quad IPv4 address literal: four ASCII decimal numbers, each 
     * between 0 and 255 inclusive, e.g. &quot;192.168.0.1&quot;.
     */
    QString address;
    /**
     * The TCP or UDP port number.
     */
    ushort port;
};

 bool operator==(const SocketAddressIPv4& v1, const SocketAddressIPv4& v2);
inline bool operator!=(const SocketAddressIPv4& v1, const SocketAddressIPv4& v2)
{
    return !operator==(v1, v2);
}
 QDBusArgument& operator<<(QDBusArgument& arg, const SocketAddressIPv4& val);
 const QDBusArgument& operator>>(const QDBusArgument& arg, SocketAddressIPv4& val);

/**
 * \struct SocketAddressIPv6
 * \ingroup struct
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Structure type generated from the specification.
 * 
 * An IPv6 address and port.
 */
struct  SocketAddressIPv6
{
    /**
     * An IPv6 address literal as specified by RFC2373 section 2.2, e.g. 
     * &quot;2001:DB8::8:800:200C:4171&quot;.
     */
    QString address;
    /**
     * The TCP or UDP port number.
     */
    ushort port;
};

 bool operator==(const SocketAddressIPv6& v1, const SocketAddressIPv6& v2);
inline bool operator!=(const SocketAddressIPv6& v1, const SocketAddressIPv6& v2)
{
    return !operator==(v1, v2);
}
 QDBusArgument& operator<<(QDBusArgument& arg, const SocketAddressIPv6& val);
 const QDBusArgument& operator>>(const QDBusArgument& arg, SocketAddressIPv6& val);

/**
 * \struct SocketNetmaskIPv4
 * \ingroup struct
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Structure type generated from the specification.
 * 
 * An IPv4 network or subnet.
 */
struct  SocketNetmaskIPv4
{
    /**
     * A dotted-quad IPv4 address literal: four ASCII decimal numbers, each 
     * between 0 and 255 inclusive, e.g. &quot;192.168.0.1&quot;.
     */
    QString address;
    /**
     * The number of leading bits of the address that must match, for this 
     * netmask to be considered to match an address.
     */
    uchar prefixLength;
};

 bool operator==(const SocketNetmaskIPv4& v1, const SocketNetmaskIPv4& v2);
inline bool operator!=(const SocketNetmaskIPv4& v1, const SocketNetmaskIPv4& v2)
{
    return !operator==(v1, v2);
}
 QDBusArgument& operator<<(QDBusArgument& arg, const SocketNetmaskIPv4& val);
 const QDBusArgument& operator>>(const QDBusArgument& arg, SocketNetmaskIPv4& val);

/**
 * \struct SocketNetmaskIPv6
 * \ingroup struct
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Structure type generated from the specification.
 * 
 * An IPv6 network or subnet.
 */
struct  SocketNetmaskIPv6
{
    /**
     * An IPv6 address literal as specified by RFC2373 section 2.2, e.g. 
     * &quot;2001:DB8::8:800:200C:4171&quot;.
     */
    QString address;
    /**
     * The number of leading bits of the address that must match, for this 
     * netmask to be considered to match an address.
     */
    uchar prefixLength;
};

 bool operator==(const SocketNetmaskIPv6& v1, const SocketNetmaskIPv6& v2);
inline bool operator!=(const SocketNetmaskIPv6& v1, const SocketNetmaskIPv6& v2)
{
    return !operator==(v1, v2);
}
 QDBusArgument& operator<<(QDBusArgument& arg, const SocketNetmaskIPv6& val);
 const QDBusArgument& operator>>(const QDBusArgument& arg, SocketNetmaskIPv6& val);

/**
 * \struct StringStringMap
 * \ingroup mapping
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Mapping type generated from the specification. Convertible with
 * QMap<QString, QString>, but needed to have a discrete type in the Qt type system.
 * 
 * A mapping from strings to strings representing extra key-value pairs.
 */
struct  StringStringMap : public QMap<QString, QString>
{
    StringStringMap() : QMap<QString, QString>() {}
    StringStringMap(const QMap<QString, QString>& a) : QMap<QString, QString>(a) {}
    StringStringMap(std::initializer_list<std::pair<QString, QString> > a) : QMap<QString, QString>(a) {}

    StringStringMap& operator=(const QMap<QString, QString>& a)
    {
        *(static_cast<QMap<QString, QString>*>(this)) = a;
        return *this;
    }
};

/**
 * \ingroup list
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Array of StringStringMap values.
 */
typedef QList<StringStringMap> StringStringMapList;

/**
 * \struct StringVariantMap
 * \ingroup mapping
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Mapping type generated from the specification. Convertible with
 * QMap<QString, QDBusVariant>, but needed to have a discrete type in the Qt type system.
 * 
 * A mapping from strings to variants representing extra key-value pairs.
 */
struct  StringVariantMap : public QMap<QString, QDBusVariant>
{
    StringVariantMap() : QMap<QString, QDBusVariant>() {}
    StringVariantMap(const QMap<QString, QDBusVariant>& a) : QMap<QString, QDBusVariant>(a) {}
    StringVariantMap(std::initializer_list<std::pair<QString, QDBusVariant> > a) : QMap<QString, QDBusVariant>(a) {}

    StringVariantMap& operator=(const QMap<QString, QDBusVariant>& a)
    {
        *(static_cast<QMap<QString, QDBusVariant>*>(this)) = a;
        return *this;
    }
};

/**
 * \ingroup list
 * \headerfile TelepathyQt/future-internal.h <TelepathyQt/future-internal.h>
 *
 * Array of StringVariantMap values.
 */
typedef QList<StringVariantMap> StringVariantMapList;


} // namespace TpFuture

Q_DECLARE_METATYPE(TpFuture::ObjectImmutablePropertiesMap)
Q_DECLARE_METATYPE(TpFuture::ObjectImmutablePropertiesMapList)
Q_DECLARE_METATYPE(TpFuture::QualifiedPropertyValueMap)
Q_DECLARE_METATYPE(TpFuture::QualifiedPropertyValueMapList)
Q_DECLARE_METATYPE(TpFuture::SocketAddressIP)
Q_DECLARE_METATYPE(TpFuture::SocketAddressIPList)
Q_DECLARE_METATYPE(TpFuture::SocketAddressIPv4)
Q_DECLARE_METATYPE(TpFuture::SocketAddressIPv6)
Q_DECLARE_METATYPE(TpFuture::SocketNetmaskIPv4)
Q_DECLARE_METATYPE(TpFuture::SocketNetmaskIPv6)
Q_DECLARE_METATYPE(TpFuture::StringStringMap)
Q_DECLARE_METATYPE(TpFuture::StringStringMapList)
Q_DECLARE_METATYPE(TpFuture::StringVariantMap)
Q_DECLARE_METATYPE(TpFuture::StringVariantMapList)
